{Issues:
   We changed all Booleans to LongBools.  Do we need to do likewise for Integers?
   How do you say "pointer to LongBool"?  (PLongBool?)
   Adding stdcall to all prototypes makes this stuff work, but why?  (C header declares
      all functions as "WINAPI PASCAL".)
   
}

unit RRDecl32;

interface

uses WinTypes;


function choosePrinter(HReport:Integer; Printer:PChar; PrSize:Integer; Port:PChar; PoSize:Integer): LongBool; far; stdcall;
function chooseReport(AppName:PChar; LibName:PChar; LSize:Integer; Rep:PChar; RSize:Integer; Username:PChar; Password:PChar; DataSource:PChar; DSize:Integer): Integer; far; stdcall;
function chooseTable(HReport:Integer; Table:PChar; TSize:Integer; DataSource:PChar; DsSize:Integer; Database:PChar; DbSize:Integer): LongBool; far; stdcall;
function endReport(HReport: Integer): LongBool; far; stdcall;
function execRuntime(HReport:Integer; bWait:LongBool; FsCmdShow: Integer; pCode: PInteger; pPageCount: PLongInt; EMsg:PChar; Emsgsize: Integer): LongBool; far; stdcall;
function getAPIVersion(APIVersion: PLongInt): LongBool; far; stdcall;
function getBeginPage(HReport: Integer; pPage: PLongInt): LongBool; far; stdcall;
function getCopies(HReport: Integer; pCopies: PInteger): LongBool; far; stdcall;
function getDBContainer(HReport:Integer; pPath:PChar; Size:Integer): LongBool; far; stdcall;
function getDisplayErrors(HReport:Integer; pDispErr: PBool): LongBool; far; stdcall;
function getDisplayStatus(HReport:Integer; pDispStatus:PBool): LongBool; far; stdcall;
function getEndPage(HReport:Integer; pPage: PLongInt): LongBool; far; stdcall;
function getErrorInfo(HReport:Integer; Msg:PChar; Size:Integer; pCode:PInteger): LongBool; far; stdcall;
function getExportDest(HReport:Integer; Dest: PChar): LongBool; far; stdcall;
function getFilter(HReport:Integer; Filter:PChar; Size:Integer): LongBool; far; stdcall;
function getFilterUsage(HReport:Integer; Usage: PChar): LongBool; far; stdcall;
function getFirstFieldName(HReport:Integer; FieldName:PChar; Size:Integer): LongBool; far; stdcall;
function getFirstFilteredFieldName(HReport:Integer; FieldName:PChar; Size:Integer; Filter:Integer): LongBool; far; stdcall;
function getFirstGroupField(HReport:Integer; GroupFldName:PChar; Size:Integer): LongBool; far; stdcall;
function getFirstRelationInfo(HReport:Integer; FilePath:PChar; FSize:Integer; IndexPath:PChar; ISize:Integer; Tag:PChar; TSize:integer; Alias:PChar; ASize:integer): LongBool; far; stdcall;
function getFirstSortField(HReport:Integer; SortFieldName:PChar; Size:Integer): LongBool; far; stdcall;
function getFirstUserParam(HReport:Integer; ParmName:PChar; NSize:Integer; PValue:PChar; VSize:Integer): LongBool; far; stdcall;
function getHighScope(HReport:Integer; Scope:PChar; Size:Integer): LongBool; far; stdcall;
function getLibrary(HReport:Integer; LibName:PChar; Size:Integer): LongBool; far; stdcall;
function getLowScope(HReport:Integer; Scope:PChar; Size:Integer): LongBool; far; stdcall;
function getMasterIndexInfo(HReport:Integer; Path:PChar; Size:Integer; pType:PChar; Tag:PChar; TSize:Integer): LongBool; far; stdcall;
function getMasterTableName(HReport:Integer; Path:PChar; Size:Integer): LongBool; far; stdcall;
function getMemoName(HReport:Integer; MemoNamePath:PChar; Size:Integer): LongBool; far; stdcall;
function getNewReportHandle(AppName:PChar): Integer; far; stdcall;
function getNextFieldName(HReport:Integer; FieldName:PChar; Size:Integer): LongBool; far; stdcall;
function getNextFilteredFieldName(HReport:Integer; FieldName:PChar; Size:Integer; Filter:Integer): LongBool; far; stdcall;
function getNextGroupField(HReport:Integer; GroupFieldName:PChar; Size:Integer): LongBool; far; stdcall;
function getNextRelationInfo(HReport:Integer; FilePath:PChar; FSize:Integer; IndexPath:PChar; ISize:Integer; Tag:PChar; TSize:integer; Alias:PChar; ASize:integer): LongBool; far; stdcall;
function getNextSortField(HReport:Integer; SortFieldName:PChar; Size:Integer): LongBool; far; stdcall;
function getNextUserParam(HReport:Integer; ParmName:PChar; NSize:Integer; Value:PChar; VSize:Integer): LongBool; far; stdcall;
function getOutputDest(HReport:Integer; Dest:PChar; Size:Integer): LongBool; far; stdcall;
function getOutputFile(HReport:Integer; OutFilePath:PChar; Size: Integer): LongBool; far; stdcall;
function getPreventEscape(HReport:Integer; pbNoEsc:PBool): LongBool; far; stdcall;
function getPrinter(HReport:Integer; Printer: PChar; Size: Integer): LongBool; far; stdcall;
function getPrinterPort(HReport:Integer; Port:PChar; Size:Integer): LongBool; far; stdcall;
function getReportPick(HReport:Integer; RepPick:PChar): LongBool; far; stdcall;
function getRuntimeRecord(AppName:PChar; Filename:PChar; Username:PChar; Password:PChar; DataSource:PChar; Size:Integer): Integer; far; stdcall;
function getScopeUsage(HReport:Integer; ScopeUse:PChar): LongBool; far; stdcall;
function getStatusEveryPage(HReport:Integer; pbEvery:PBool): LongBool; far; stdcall;
function getTestPattern(HReport:Integer; pbTest:PBool): LongBool; far; stdcall;
function getWinTitle(HReport:Integer; Title:PChar; Size:Integer): LongBool; far; stdcall;
function resetErrorInfo(HReport:Integer): LongBool; far; stdcall;
function setBeginPage(HReport: Integer; Page: LongInt): LongBool; far; stdcall;
function setCopies(HReport: Integer; Copies: Integer): LongBool; far; stdcall;
function setDataDir(HReport:Integer; Directory:PChar): LongBool; far; stdcall;
function setDBContainer(HReport:Integer; Path:PChar): LongBool; far; stdcall;
function setDisplayErrors(HReport:Integer; bDispErr: LongBool): LongBool; far; stdcall;
function setDisplayStatus(HReport:Integer; bDispStatus: LongBool): LongBool; far; stdcall;
function setEndPage(HReport: Integer; Page: LongInt): LongBool; far; stdcall;
function setExportDest(HReport:Integer; ExpDest: char ): LongBool; far; stdcall;
function setFilter(HReport:Integer; Filter: PChar): LongBool; far; stdcall;
function setFilterUsage(HReport:Integer; Usage:Char): LongBool; far; stdcall;
function setGroupField(HReport:Integer; GroupFieldName:PChar; GroupFieldNum:Integer): LongBool; far; stdcall;
function setHighScope(HReport:Integer; Scope:PChar): LongBool; far; stdcall;
function setImageDir(HReport:Integer; Dir:PChar): LongBool; far; stdcall;
function setIndexExtension(HReport:Integer; ExtNumber:Integer): LongBool; far; stdcall;
function setLibrary(HReport:Integer; LibName:PChar): LongBool; far; stdcall;
function setLibraryDir(HReport:Integer; DirName:PChar): LongBool; far; stdcall;
function setLowScope(HReport:Integer; Scope:PChar): LongBool; far; stdcall;
function setMasterIndexInfo(HReport:Integer; Path:PChar; pType:Char; Tag:PChar): LongBool; far; stdcall;
function setMasterTableName(HReport:Integer; MastFileName:PChar): LongBool; far; stdcall;
function setMemoName(HReport:Integer; MemoPath:PChar): LongBool; far; stdcall;
function setOutputDest(HReport:Integer; Dest:PChar): LongBool; far; stdcall;
function setOutputFile(HReport:Integer; Filename:PChar): LongBool; far; stdcall;
function setPassword(HReport:Integer; Password:PChar): LongBool; far; stdcall;
function setPreventEscape(HReport:Integer; bNoEsc:LongBool): LongBool; far; stdcall;
function setPrinter(HReport:Integer; Printer:PChar): LongBool; far; stdcall;
function setPrinterPort(HReport:Integer; Port:PChar): LongBool; far; stdcall;
function setRelationInfo(HReport:Integer; Path:PChar; IndexPath:PChar; Tag:PChar; Alias:PChar; AliasNum:Integer): LongBool; far; stdcall;
function setReportPick(HReport:Integer; RepPick:Char): LongBool; far; stdcall;
function setScopeUsage(HReport:Integer; ScopeFlag:Char): LongBool; far; stdcall;
function setSortField(HReport:Integer; SortFieldName:PChar; SortNum:Integer): LongBool; far; stdcall;
function setStatusEveryPage(HReport:Integer; bValue:LongBool): LongBool; far; stdcall;
function setStatusFileName(HReport:Integer; Filename:PChar): LongBool; far; stdcall;
function setSuppressTitle(HReport:Integer; bValue:LongBool): LongBool; far; stdcall;
function setTestPattern(HReport:Integer; bValue:LongBool): LongBool; far; stdcall;
function setUserParam(HReport:Integer; ParamName:PChar; Value:PChar): LongBool; far; stdcall;
function setWinBorderStyle(HReport:Integer; Style:Integer): LongBool; far; stdcall;
function setWinControlBox(HReport:Integer; ControlBox:LongBool): LongBool; far; stdcall;
function setWinHeight(HReport:Integer; Height:Integer): LongBool; far; stdcall;
function setWinLeft(HReport:Integer; Left:Integer): LongBool; far; stdcall;
function setWinMaxButton(HReport:Integer; bAllow:LongBool): LongBool; far; stdcall;
function setWinMinButton(HReport:Integer; bAllow:LongBool): LongBool; far; stdcall;
function setWinParentHandle(HReport:Integer; Parent:Integer): LongBool; far; stdcall;
function setWinTitle(HReport:Integer; WinTitle:PChar): LongBool; far; stdcall;
function setWinTop(HReport:Integer; WinTop:Integer): LongBool; far; stdcall;
function setWinWidth(HReport:Integer; WinWidth:Integer): LongBool; far; stdcall;
function setWriteAllow(HReport:Integer; bAllow:LongBool): LongBool; far; stdcall;
function setXBaseEditor(HReport:Integer; bXBase:LongBool): LongBool; far; stdcall;
function writeRuntimeRecord(HReport:Integer; RecordFile:PChar): LongBool; far; stdcall;


implementation

function ChoosePrinter; external 'RSRPT32.DLL' name 'choosePrinter';
function ChooseReport; external 'RSRPT32.DLL' name 'chooseReport';
function ChooseTable; external 'RSRPT32.DLL' name 'chooseTable';
function EndReport; external 'RSRPT32.DLL' name 'endReport';
function ExecRuntime; external 'RSRPT32.DLL' name 'execRuntime';
function GetAPIVersion; external 'RSRPT32.DLL' name 'getAPIVersion';
function GetBeginPage; external 'RSRPT32.DLL' name 'getBeginPage';
function GetCopies; external 'RSRPT32.DLL' name 'getCopies';
function GetDBContainer;external 'RSRPT32.DLL' name 'getDBContainer';
function GetDisplayErrors; external 'RSRPT32.DLL' name 'getDisplayErrors';
function GetDisplayStatus; external 'RSRPT32.DLL' name 'getDisplayStatus';
function GetEndPage; external 'RSRPT32.DLL' name  'getEndPage';
function GetErrorInfo; external 'RSRPT32.DLL' name 'getErrorInfo';
function GetExportDest; external 'RSRPT32.DLL' name 'getExportDest';
function GetFilter; external 'RSRPT32.DLL' name 'getFilter';
function GetFilterUsage; external 'RSRPT32.DLL' name 'getFilterUsage';
function GetFirstFieldName; external 'RSRPT32.DLL' name 'getFirstFieldName';
function GetFirstFilteredFieldName; external 'RSRPT32.DLL' name 'getFirstFilteredFieldName';
function GetFirstGroupField; external 'RSRPT32.DLL' name 'getFirstGroupField';
function GetFirstRelationInfo; external 'RSRPT32.DLL' name 'getFirstRelationInfo';
function GetFirstSortField; external 'RSRPT32.DLL' name 'getFirstSortField';
function GetFirstUserParam; external 'RSRPT32.DLL' name 'getFirstUserParam';
function GetHighScope; external 'RSRPT32.DLL' name 'getHighScope';
function GetLibrary; external 'RSRPT32.DLL' name 'getLibrary';
function GetLowScope; external 'RSRPT32.DLL' name 'getLowScope';
function GetMasterIndexInfo; external 'RSRPT32.DLL' name 'getMasterIndexInfo';
function GetMasterTableName; external 'RSRPT32.DLL' name 'getMasterTableName';
function GetMemoName; external 'RSRPT32.DLL' name 'getMemoName';
function GetNewReportHandle; external 'RSRPT32.DLL' name 'getNewReportHandle';
function GetNextFieldName; external 'RSRPT32.DLL' name 'getNextFieldName';
function GetNextFilteredFieldName; external 'RSRPT32.DLL' name 'getNextFilteredFieldName';
function GetNextGroupField; external 'RSRPT32.DLL' name 'getNextGroupField';
function GetNextRelationInfo; external 'RSRPT32.DLL' name 'getNextRelationInfo';
function GetNextSortField; external 'RSRPT32.DLL' name 'getNextSortField';
function GetNextUserParam; external 'RSRPT32.DLL' name 'getNextUserParam';
function GetOutputDest; external 'RSRPT32.DLL' name 'getOutputDest';
function GetOutputFile; external 'RSRPT32.DLL' name 'getOutputFile';
function GetPreventEscape; external 'RSRPT32.DLL' name 'getPreventEscape';
function GetPrinter; external 'RSRPT32.DLL' name 'getPrinter';
function GetPrinterPort; external 'RSRPT32.DLL'name 'getPrinterPort';
function GetReportPick; external 'RSRPT32.DLL' name 'getReportPick';
function GetRunTimeRecord; external 'RSRPT32.DLL' name 'getRunTimeRecord';
function GetScopeUsage; external 'RSRPT32.DLL' name  'getScopeUsage';
function GetStatusEveryPage; external 'RSRPT32.DLL' name 'getStatusEveryPage';
function GetTestPattern; external 'RSRPT32.DLL' name 'getTestPattern';
function GetWinTitle; external 'RSRPT32.DLL' name 'getWinTitle';
function ResetErrorInfo; external 'RSRPT32.DLL' name 'resetErrorInfo';
function SetBeginPage; external 'RSRPT32.DLL' name 'setBeginPage';
function SetCopies; external 'RSRPT32.DLL' name 'setCopies';
function SetDataDir; external 'RSRPT32.DLL' name 'setDataDir';
function SetDBContainer; external 'RSRPT32.DLL' name 'setDBContainer';
function SetDisplayErrors; external 'RSRPT32.DLL' name 'setDisplayErrors';
function SetDisplayStatus; external 'RSRPT32.DLL' name 'setDisplayStatus';
function SetEndPage; external 'RSRPT32.DLL' name 'setEndPage';
function SetExportDest; external 'RSRPT32.DLL' name 'setExportDest';
function SetFilter; external 'RSRPT32.DLL' name 'setFilter';
function SetFilterUsage; external 'RSRPT32.DLL' name 'setFilterUsage';
function SetGroupField; external 'RSRPT32.DLL' name 'setGroupField';
function SetHighScope; external 'RSRPT32.DLL' name 'setHighScope';
function SetImageDir; external 'RSRPT32.DLL' name 'setImageDir';
function SetIndexExtension; external 'RSRPT32.DLL' name 'setIndexExtension';
function SetLibrary; external 'RSRPT32.DLL' name 'setLibrary';
function SetLibraryDir; external 'RSRPT32.DLL' name 'setLibraryDir';
function SetLowScope; external 'RSRPT32.DLL' name 'setLowScope';
function SetMasterIndexInfo; external 'RSRPT32.DLL' name 'setMasterIndexInfo';
function SetMasterTableName; external 'RSRPT32.DLL' name 'setMasterTableName';
function SetMemoName; external 'RSRPT32.DLL' name 'setMemoName';
function SetOutputDest; external 'RSRPT32.DLL' name 'setOutputDest';
function SetOutputFile; external 'RSRPT32.DLL' name 'setOutputFile';
function SetPassword; external 'RSRPT32.DLL' name 'setPassword';
function SetPreventEscape; external 'RSRPT32.DLL' name  'setPreventEscape';
function SetPrinter; external 'RSRPT32.DLL' name 'setPrinter';
function SetPrinterPort; external 'RSRPT32.DLL' name 'setPrinterPort';
function SetRelationInfo; external 'RSRPT32.DLL'name 'setRelationInfo';
function SetReportPick; external 'RSRPT32.DLL' name 'setReportPick';
function SetScopeUsage; external 'RSRPT32.DLL' name 'setScopeUsage';
function SetSortField; external 'RSRPT32.DLL' name 'setSortField';
function SetStatusEveryPage; external 'RSRPT32.DLL' name 'setStatusEveryPage';
function SetStatusFileName; external 'RSRPT32.DLL' name 'setStatusFileName';
function SetSuppressTitle; external 'RSRPT32.DLL' name 'setSuppressTitle';
function SetTestPattern; external 'RSRPT32.DLL' name 'setTestPattern';
function SetUserParam; external 'RSRPT32.DLL' name 'setUserParam';
function SetWinBorderStyle; external 'RSRPT32.DLL' name 'setWinBorderStyle';
function SetWinControlBox; external 'RSRPT32.DLL' name 'setWinControlBox';
function SetWinHeight; external 'RSRPT32.DLL' name 'setWinHeight';
function SetWinLeft; external 'RSRPT32.DLL' name 'setWinLeft';
function SetWinMaxButton; external 'RSRPT32.DLL' name 'setWinMaxButton';
function SetWinMinButton; external 'RSRPT32.DLL' name 'setWinMinButton';
function SetWinParentHandle; external 'RSRPT32.DLL' name 'setWinParentHandle';
function SetWinTitle; external 'RSRPT32.DLL' name 'setWinTitle';
function SetWinTop; external 'RSRPT32.DLL' name 'setWinTop';
function SetWinWidth; external 'RSRPT32.DLL' name 'setWinWidth';
function SetWriteAllow; external 'RSRPT32.DLL' name 'setWriteAllow';
function SetXBaseEditor; external 'RSRPT32.DLL' name 'setXBaseEditor';
function WriteRuntimeRecord; external 'RSRPT32.DLL' name 'writeRuntimeRecord';

end.


